<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Arrow Functions Demo</title>
</head>

<body>
    <script>
        let cities = [
            {
                name: 'Tallinn',
                country: 'Estonia',
                population: 434562
            },
            {
                name: 'Tartu',
                country: 'Estonia',
                population: 93865
            },
            {
                name: 'Valga',
                country: 'Estonia',
                population: 12992
            },
            {
                name: 'Võru',
                country: 'Estonia',
                population: 12367
            },
            {
                name: 'Helsinki',
                country: 'Finland',
                population: 650058
            },
            {
                name: 'Espoo',
                country: 'Finland',
                population: 284444
            },
            {
                name: 'Hanko',
                country: 'Finland',
                population: 8386
            },
            {
                name: 'Jämsä',
                country: 'Finland',
                population: 20589
            },
            {
                name: 'Stockholm',
                country: 'Sweden',
                population: 972647
            },
            {
                name: 'Uppsala',
                country: 'Sweden',
                population: 168096
            },
            {
                name: 'Lund',
                country: 'Sweden',
                population: 91940
            },
            {
                name: 'Köping',
                country: 'Sweden',
                population: 17743
            }
        ];

        // 1) cities.find() - leia esimene element massiivist, mis vastab tingimusele

        // Klassikaline funktsioon
        // const myTartu = cities.find(
        //     function (xxx) {
        //         if (xxx.name === 'Tartu') {
        //             return true;
        //         } else {
        //             return false;
        //         }
        //     }
        // )

        // Noolefunktsioon
        const myTartu = cities.find(x => x.name === 'Tartu')
        console.log(myTartu);
        
        const firstLargeCity = cities.find(y => y.population > 100000);
        console.log(firstLargeCity);

        // 2) cities.filter() - tagasta kõik objektid, mis kvalifitseeruvad minu tingimustele
        const largeCities = cities.filter(k => k.population >= 100000);
        console.log(largeCities);

        // 3) cities.every() - kas kõik elemendid massiivis kvalifitseeruvad
        const allQualifying = cities.every(l => l.name.length > 3);
        console.log(allQualifying);
        
        const allStrings = cities.every(p => typeof p.name === "string");
        console.log(allStrings);

        // 4) cities.some() - kas vähemalt üks element kvalifitseerub
        const extraLargeExists = cities.some(p => p.population > 500000);
        console.log(extraLargeExists);

        // 5) cities.map() - muuda iga element massiivis millekski muuks
        const cityHumanReadibleList = cities.map(city => city.name + ", elanikke: " + city.population);
        console.log(cityHumanReadibleList);

        const citiesObjectsInEstonian = cities.map(c => { return { nimi: c.name, inimesi: c.population }; });
        console.log(citiesObjectsInEstonian);

        // 6) cities.reduce() - agregeeri massiivielemendid mingi kriteeriumi alusel kokku
        let totalPopulation = 0;
        for (const city of cities) {
            totalPopulation = totalPopulation + city.population;
        }
        console.log('Inimesi kokku: ' + totalPopulation);
        const totalPopulation2 = cities.reduce(
            (currentTotal, city) => currntTotal = currentTotal + city.population, 0);
        console.log('Inimesi kokku (2): ' + totalPopulation2);
        
        // 7) cities.forEach() - rakenda mingit operatsiooni kõigile elementidele massiivis, EI TAGASTA MIDAGI!
        let totalPopulation3 = 0;
        cities.forEach(c => totalPopulation3 = totalPopulation3 + c.population);
        console.log('Inimesi kokku (3): ' + totalPopulation3);

    </script>
</body>

</html>